#line 1 ".\Src\main.c"
#line 1 "D:\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\main.c"
#line 1 ".\Include\FC2720.h"


#line 6 ".\Include\FC2720.h"








struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;

	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;






sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;

sbit	LVDF =0x86:5;















 sfr    TM1M    =0XA0;
 sfr    TM1C   =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1  =0XA3;
 sfr    TM1D2  =0XA4;
 sfr    TM1D3  =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;

 sfr    TM2M    =0XB0;
 sfr    TM2C   =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1  =0XB3;
 sfr    TM2D2  =0XB4;
 sfr    TM2D3  =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;

 sfr    TKCON=  0X88;
 sfr    TKTMD =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKMIO  =0X8F;

 sfr    ADM =0XB9;
 sfr    ADB =0XBa;
 sfr    ADR =0XBb;
 sfr    ADT =0XBc;
 sfr    VREFH =0XBd;
 sfr    ADPCON =0XBe;
 sfr	PEDGE =0XBF;

 sfr    P1W = 0XC0;
 sfr	P1M = 0xc1;
 sfr	P3M=0XC3;
 sfr    INTRQ1 = 0XC6;
 sfr    INTEN1 = 0XC7;
 sfr    INTRQ = 0XC8;
 sfr    INTEN = 0XC9;
 sfr	OSCM = 0xca;
 sfr	RCADJ =0XCB;
 sfr	WDTR =0XCC;
 sfr    OPTION = 0XCD;
 sfr	PCL =0XCE;
 sfr	PCH =0XCF;

 sfr	P1 = 0XD1;
 sfr	P2 = 0XD2;
 sfr	P3 = 0XD3;
 sfr	T0M = 0XD8;
 sfr	T0C = 0XD9;
 sfr    OPA1CON = 0XDA;
 sfr    OPA2CON = 0XDB;
 sfr    P1OD = 0XDC;
 sfr    P3W = 0XDE;
 sfr    STKP = 0XDF;

 sfr	P1UR=0Xe1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;

 sfr	P1PD=0XEC;
 sfr	P3PD=0XEE;

sbit	FP37UR = 0XE3:7;

sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAA:2;
sbit	E2P_PG		=0xA9:1;
sbit	E2P_RD		=0xA8:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	FCHS0		=0xB9:0;
sbit	FCHS1		=0xB9:1;
sbit	FCHS2		=0xB9:2;
sbit	FCHS3		=0xB9:3;
sbit	FGCHS		=0xB9:4;
sbit	FEOC		=0xB9:5;
sbit	FADS		=0xB9:6;
sbit	FADENB		=0xB9:7;



sbit	FADCKS0		=0xBB:4;
sbit	FADCKS1		=0xBB:6;



sbit	FADT_0		=0xBc:0;
sbit	FADT_1		=0xBC:1;
sbit	FADT_2		=0xBC:2;
sbit	FADT_3		=0xBC:3;
sbit	FADT_4		=0xBC:4;

sbit	Fadts_0		=0xBC:6;
sbit	Fadts_1		=0xBC:7;


sbit	FVHS0		=0xBD:0;
sbit	FVHS1		=0xBD:1;

sbit	FEVHENB		=0xBD:7;






sbit	FINT0IE		=0xc9:0;
sbit	FINT1IE		=0xc9:1;
sbit	FTM0IE		=0xc9:2;
sbit	FTM1IE		=0xc9:3;
sbit	FTM2IE		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	FI2CIE		=0xc9:6;
sbit	FADCIE		=0xc9:7;

sbit	FE2PIE		=0xc7:0;
sbit	FTKTMRIE	=0xc7:1;
sbit	FSPIIE		=0xc7:2;
sbit	FT0IE	    =0xC7:3;
sbit	FOPAIE    	=0xC7:4;

sbit	FINT0IF		=0xc8:0;
sbit	FINT1IF		=0xc8:1;
sbit	FTM0IF		=0xc8:2;
sbit	FTM1IF		=0xc8:3;
sbit	FTM2IF		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	FI2CIF		=0xc8:6;
sbit	FADCIF		=0xc8:7;

sbit	FE2PIF		=0xc6:0;
sbit	FTKTMRIF	=0xc6:1;
sbit	FSPIIF		=0xc6:2;
sbit	FT0IF	    =0xC6:3;
sbit	FOPAIF    	=0xC6:4;


sbit	FGIE = 0xdf:7;


sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;


sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;













#line 2 ".\Src\main.c"

enum status
{
  POWER_ON,DANGWEI,CHRGING,STDBY,SLEEPING
};














bit       bit1ms=0;
bit       bit5ms=0;
bit       bit10ms=0;
bit       bit10ms_1=0;
bit       bit10ms_2=0;
bit       bit10ms_3=0;
bit       bit10ms_4=0;

bit       bit100ms=0;
bit       bit200ms=0;
bit       bit200ms_1=0;
bit       bitshorton=0;
bit       bitkey_short=0;
bit       bitok=0;
bit       bit_jianbian=0;
bit       bitkey_long=0;
bit       bitkeylock1=0;
bit       begin=0;
bit       bitChrg=0;
bit       bitChek=0;




bit       bit11=0;
bit       bit12=0;
bit       bit15=0;
bit       bit16=0;
bit       bit17=0;
bit       bit18=0;
bit       bit19=0;
bit       F_PWM=0;

bit       u8Mode_update=0;

bit       bitvol_2_9=0;











#line 82 ".\Src\main.c"

 unsigned char   u8AdcLast;
 unsigned char   u8AdcNow;
 unsigned char   u8AdcFilterValue;
 unsigned char   cnt=0;



 unsigned char    u8duty=0;
 unsigned char    u8duty2=0;
 unsigned char    u8step=0;

 unsigned char    x=0,y=0,i=0;

 unsigned char   a=0,b=0,f=0,q=0,s=0,m=0,e=0,h=0,u=0;


 unsigned long int   c=0,d=0,t=0;

 unsigned char    u8Mode=0;
enum status u8Status=SLEEPING;


void delay_xms(unsigned char x_ms);

void SysInit(void);
void scan_key(void);

void Get_ADC(void);
void time_jiange(void);
void t0_enable(void);
void t0_disable(void);
void pwm_disable(void);
void pwm_enable(void);
void ADC_Init(void);
void pwm_fuzhi(void);


#line 127 ".\Src\main.c"
void __interrupt[0x8] isr(void)
{
  static unsigned char j=0,r=0,z=0,u=0,q=0;

  if(FT0IF)
  {
    T0C=219;
	FT0IF=0;

#line 139 ".\Src\main.c"

	u++;
	if(u>4)
	{
	  u=0;

	  bit1ms=1;
	  z++;
      j++;
      r++;
	 }

    if(r>9)
    {
	  r=0;
      bit10ms=1;
	  bit10ms_1=1;
      bit10ms_2=1;
	  bit10ms_3=1;
	  bit10ms_4=1;
    }

    if(j>4)
	{
	  j=0;
      bit5ms=1;
	}

    if(z>199)
	{
	  z=0;
      bit200ms=1;

	 }



	if(begin)
	{
	  if(bit17==0)
	  {
	     FP34=1;
		 q++;
		 if(q>h)
		 {
		   q=0;
		   bit17=1;
         }
       }
	   if(bit17==1)
	   {
	      FP34=0;
		  q++;
		  if(q>50-h)
		  {
		    q=0;
			bit17=0;
			m++;
			if(m>2)
			{
			   m=0;
			   if(bit11==0)
			   {
			   h++;
			   if(h>49)
			   {
				  bit11=1;
                }
			   }
               if(bit11==1)
			   {
			    h--;
				if(h<2)
				{
				  bit11=0;
                 }
                }
             }
           }

        }



	 }
  }
  INTRQ=0;
  INTRQ1=0;
}

#line 236 ".\Src\main.c"
void main(void)
{

   u8Status=SLEEPING;
   u8Mode=1;



#line 254 ".\Src\main.c"










    while(1)
    {

		WDTR=0X5A;

		switch(u8Status)
		{
		  case POWER_ON:

	      if(bit1ms)
		  {
		    bit1ms=0;
		    c++;
			Get_ADC();


#line 314 ".\Src\main.c"
			if(c<400)
			break;
			c=0;
			u8Mode_update=1;
			if(u8AdcFilterValue<108)
			{
			  bit15=1;
             }
            if(u8AdcFilterValue<96)
			{
			  bit15=0;
			  bit16=1;
			  u8Mode_update=0;
             }
			u8Status=DANGWEI;
		    }
		   break;


		  case  DANGWEI:

		   if(bit1ms)
		   {
		      x++;
		      bit1ms=0;
			  Get_ADC();
			  if(x>9)
			  {
			     x=0;
			     scan_key();
               }
              if(bitChek==0)
			  {
			     u8Status=CHRGING;
                 h=1;
                 m=0;
				 bit11=0;
				 bit17=0;

				 break;
               }
			  if(bitkey_long)
			  {
			     bitkey_long=0;
				 u8Status=SLEEPING;
				 break;
               }
			 if(F_PWM)
			 {
              if(u8AdcFilterValue<108)
             {
				   m++;
				  if(m>50)
				 {
                    m=0;
					bit15=1;
                  }
              }
			 else
			 {
			     m=0;
			  }

              if(u8AdcFilterValue<96)
			    {
			       e++;
				  if(e>50)
				  {
					 e=0;
				     bit16=1;
                   }
				}
				else
				{
				   e=0;
				 }
			   }



			 if(bitvol_2_9==0)
			 {
			 if(bit15)
			 {
				   if(bit10ms)
				    {
				    bit10ms=0;
					c++;
					if(c>17)
					{
					   c=0;
					   P3^=0x20;
                     }
                    }
              }
			  }

               if(bit16)
				 {
			      bitvol_2_9=1;
			      pwm_disable();

			     if(bit10ms_1)
				 {
				    bit10ms_1=0;
					y++;
					t++;
					if(y>10)
					{
					   y=0;
					   P3^=0x20;
                    }
                    if(t>500)
					{
                       t=0;
                       u8Status=SLEEPING;
                       break;
					 }
				  }
                 }

			   if(bit200ms)
                {
					bit200ms=0;
					d++;
					a++;
					b++;
					if(d>580)
					{
					    d=0;
						u8Status=SLEEPING;
					    break;
					 }
                 }

				if(bitvol_2_9==0)
				{
                if(a<50)
				{
				  if(bitkey_short)
				 {
					bitkey_short=0;
					d=0;
					b=0;
					a=0;
					f=0;
				    u8Mode++;
					if(u8Mode>3)
					{
					  u8Mode=1;
					 }
                    u8Mode_update=1;
					u8step=0;
                  }
                 }
				else
				{
				   if(bitkey_short)
			  	  {
					 bitkey_short=0;
	             	 u8Status=SLEEPING;
					 break;
                   }
                 }


			   switch(u8Mode)
			     {
                     case 1:
                          if(u8Mode_update)
						  {
						    u8Mode_update=0;
							u8duty=235;
							u8duty2=172;
						    pwm_enable();
							delay_xms(26);
                            pwm_fuzhi();
						  }
                          time_jiange();
                    	  break;

                     case 2:
                          if(u8Mode_update)
						  {
						    u8Mode_update=0;
							u8duty=226;
							u8duty2=168;
							pwm_enable();
						    delay_xms(26);
                            pwm_fuzhi();
						  }
                          time_jiange();
                    	  break;

                     case 3:
						  switch(u8step)
						  {
						  case 0:
                          if(u8Mode_update)
						  {
						    u8Mode_update=0;
							u8duty=227;
							u8duty2=183;
							pwm_enable();
							delay_xms(23);
                            pwm_fuzhi();
						  }
						  if(bit10ms_2)
						   {
                              bit10ms_2=0;
							  q++;
							  if(q>9)
							  {
							     q=0;
                                 u8step=3;
								 bit11=1;
							   }
                            }
							break;
                          case 1:
                           if(u8Mode_update)
						  {
						    u8Mode_update=0;
							u8duty=235;
							u8duty2=172;
							pwm_enable();
							delay_xms(26);
                            pwm_fuzhi();
						  }
						  if(bit10ms_2)
						   {
                              bit10ms_2=0;
							  q++;
							  if(q>9)
							  {
							     q=0;
                                 u8step=3;
								 bit18=1;
							   }
                            }
							break;

                          case 2:
                          if(u8Mode_update)
						  {
						    u8Mode_update=0;
							u8duty=232;
							u8duty2=162;
							pwm_enable();
							delay_xms(29);
                            pwm_fuzhi();
						  }
						  if(bit10ms_2)
						   {
                              bit10ms_2=0;
							  q++;
							  if(q>13)
							  {
							     q=0;
                                 u8step=3;
								 bit17=1;
							   }
                            }
							break;

                           case 3:
						   if(F_PWM==0)
						   {
                           pwm_disable();
						   if(bit10ms_2)
						   {
                              bit10ms_2=0;
							  q++;
							  if(q>4)
							  {
							     q=0;
                                 if(bit11)
								 {
                                   u8step=1;
								   bit11=0;
                                  }
                                 if(bit18)
								 {
                                   u8step=2;
								   bit18=0;
                                  }
								 if(bit17)
								 {
                                   u8step=0;
								   bit17=0;
                                 }
								 u8Mode_update=1;
							   }
                            }
							}
							break;
							}

                          time_jiange();
                    	  break;
                         }
                        }
				   }
				   break;

		   case CHRGING:

		          pwm_disable();
                  FP35=0;

#line 673 ".\Src\main.c"
				  begin=1;

#line 695 ".\Src\main.c"


		          if(bit10ms_4)
				  {
				    bit10ms_4=0;
					scan_key();
				  if(bitChrg==0)
				  {
                     u8Status=STDBY;
					 break;
                   }
				  if(bitChek&&bitChrg)
				  {
					 u8Status=SLEEPING;
					 break;
                   }


                  }
				   break;

             case STDBY:

				  begin=0;
		          FP34=1;
		          if(bit10ms_4)
				  {
				    bit10ms_4=0;
					scan_key();
				  if(bitChrg&&bitChek)
				  {
					 FP34=0;
					 u8Status=SLEEPING;
					 break;
                   }
                   }
				   break;

		  case SLEEPING:

		  SysInit();
		  bitkeylock1=1;

          for(x=0;x<10;x++)
          {


            if(bitkeylock1)x=0;



            scan_key();
            delay_xms(122);
          }

#line 754 ".\Src\main.c"



		  bitChrg=1;
		  bitChek=1;

		  F_PWM=0;


		  begin=0;

		  bitvol_2_9=0;
		  SysInit();
          INTEN=0x20;
		  do
		  {
 __asm{SleepMode};
		  }while(FP32 && FP37);
    	  INTEN=0x00;


         if(FP32 ==0)
		  {
			bitChek=0;
			bitChrg=1;


		    h=1;
			m=0;
			bit11=0;
			bit17=0;
			t0_enable();
	        u8Status=CHRGING;
	        break;
	      }

	      if(FP37 ==0)
	      {
	        x=0;
	        while(1)
	        {
	          x++;
              if(FP37 ==0)x=0;
              if(x>2)break;

			  WDTR=0X5A;
	          delay_xms(122);

       	      scan_key();
			  if(bitkey_short)
			  {
				bitkey_short=0;
                bitkey_long=0;
				bitkeylock1=1;
	            a=0,b=0,c=0,d=0,y=0,e=0;
		        f=0,q=0,m=0,x=0,t=0;
		        bit11=0;

				bit15=0;
				bit16=0;
				bit17=0;
				bit18=0;
				u8step=0;
			    ADC_Init();
				t0_enable();
			    u8Status=POWER_ON;
				FP35=1;

                break;
			  }
	        }
	      }
		  break;

	}
  }
}

#line 839 ".\Src\main.c"
void ADC_Init(void)
{

  ADPCON=0x00;
  VREFH=0x00;
  ADR=0X20;
  ADM=0x9A;
}

#line 855 ".\Src\main.c"
void pwm_fuzhi(void)
{
    TM2C=u8duty2;
    TM2D2=u8duty;
}


void pwm_enable(void)
{
  TM1D0=u8duty;
  TM1C=u8duty2;

  PWM1E=0x10;
  TM1M=0x83;



  TM2D2=u8duty;
  TM2C=u8duty2;
  PWM2E=0x42;
  TM2M=0x82;
}

void pwm_disable(void)
{
   FP14=0;
   FP36=0;
   PWM2E=0x00;
   TM2M=0x00;
   PWM1E=0x00;
   TM1M=0x00;
}
void  time_jiange(void)
{

							 if(b>147)
							 {
							   	F_PWM=1;
								pwm_disable();
								if(bit5ms)
								{
								  bit5ms=0;
                                  f++;
								if(f>100)
								{
								   f=0;
                                   b=0;
								   F_PWM=0;
								   m=0,e=0;
                                   u8Mode_update=1;
								 }
							    }

                              }
}


#line 921 ".\Src\main.c"
void scan_key(void)
{
  static unsigned char u8Count1=0;
  static unsigned char u8Count2=0;

  static unsigned char u8Count3=0;
  static unsigned char u8Count4=0;
  static unsigned char u8Count5=0;
  static unsigned char u8Count6=0;





  if(FP32)
  {
      u8Count3++;
	  u8Count4=0;
	  if(u8Count3>55)
	  {
       u8Count3=0;
       bitChek=1;
	   }
   }
   else
   {
     u8Count3=0;
      u8Count4++;
	  if(u8Count4>0)
	  {
       u8Count4=0;
       bitChek=0;
	   }
   }

  if(FP33)
  {
      u8Count6=0;
      u8Count5++;
	  if(u8Count5>30)
	  {
       u8Count5=0;
       bitChrg=1;
	   }
   }
   else
   {
      u8Count5=0;
      u8Count6++;
	  if(u8Count6>30)
	  {
       u8Count6=0;
       bitChrg=0;
	   }
   }





  if(FP37)
  {
      u8Count1=0;
      bitkeylock1=0;
	  if(bitshorton==1)
	  {
	     bitshorton=0;
		 bitkey_short=1;
	  }
  }
  else if(bitkeylock1==0)
  {
    u8Count1++;
    if(u8Count1>3)
    {
	   bitshorton=1;
	}

    if(u8Count1>100)
	{
	   u8Count1=0;
	   bitshorton=0;

	   bitkeylock1=1;
	   bitkey_long=1;
    }
	}



#line 1025 ".\Src\main.c"

  }



#line 1037 ".\Src\main.c"

#line 1068 ".\Src\main.c"


#line 1077 ".\Src\main.c"

#line 1101 ".\Src\main.c"

void Get_ADC(void)
{

#line 1107 ".\Src\main.c"
  u8AdcLast=u8AdcNow;
  FADS =1;
  while(FADS);
  u8AdcNow=ADB;





#line 1150 ".\Src\main.c"


#line 1179 ".\Src\main.c"
if(u8AdcLast==u8AdcNow)
  {
    cnt++;
    if(cnt>3)
    {
      cnt=0;
	  u8AdcFilterValue=u8AdcNow;
    }
  }
  else
  {
    cnt=0;
  }
}

#line 1214 ".\Src\main.c"

#line 1222 ".\Src\main.c"

#line 1239 ".\Src\main.c"

void delay_xms(unsigned char x_ms)
{
 unsigned char i=0;
  WDTR=0x5A;
  for(;x_ms>0;x_ms--)
  {
    for(i=50;i>0;i--)
	{
      __asm{nop};
	  __asm{nop};
	  __asm{nop};
	  __asm{nop};
      __asm{nop};
      __asm{nop};
    }
  }
}

#line 1267 ".\Src\main.c"
void t0_enable(void)
{
  T0M=0xC0;
  T0C=219;
  FT0IE=1;
  FGIE=1;
}

#line 1284 ".\Src\main.c"


#line 1293 ".\Src\main.c"
void SysInit(void)
{
  ADPCON=0x00;
  ADR  =0x00;
  VREFH=0x00;
  ADM  =0x00;

  T0M=0x00;
  FT0IE=0;
  TM1M =0x00;
  TM2M =0x00;
  PWM1E=0x00;
  PWM2E=0x00;


#line 1316 ".\Src\main.c"

  P1   =0x00;
  P1M  =0xFF;
  P1W  =0x00;
  P1UR =0x00;
  P1PD =0x00;

  P3   =0x8C;
  P3M  =0x73;
  P3W  =0x84;
  P3UR =0x8C;
  P3PD =0x00;

}
